*    Convert an integer to hexadecimal. 

FUNCTION dectohex           && takes a positive number,
PARAMETERS Decimal          && returns a string
PRIVATE D,H
D=int(Decimal)
H=""
DO WHILE D>0
  H=substr("0123456789ABCDEF",mod(D,16)+1,1)+H
  D=int(D/16)
ENDDO
RETURN iif(""=H,"0",H)

*    Convert hexadecimal string to number    

FUNCTION hextodec           && takes a string,
PARAMETERS Hex              && returns a number
PRIVATE D,H
H=Hex
D=0
DO WHILE len(H)>0
  D=D*16+at(upper(left(H,1)),"123456789ABCDEF")
  H=substr(H,2)
ENDDO
RETURN D

*    Find a file using the DOS path.  If file exists in
*    the current directory, returns its name.
*    Otherwise, if it exists on the DOS path, returns
*    the filespec of the file of that name first found
*    on the path.  If not found, returns null string.

*    Note: this function ignores any path set by the
*    dBASE SET PATH command.

FUNCTION dosfindf
PARAMETERS Anyfile
PRIVATE Path,Semi,Nextdir,Fname
Fname=Anyfile
IF File(Fname)
  RETURN Fname
ELSE  
  Path=getenv("PATH")
  DO WHILE .NOT. file(Fname)
    IF ""=Path
      EXIT
    ENDIF
    Semi=at(";",Path)
    Nextdir=iif(Semi>0,left(Path,Semi-1),Path)
    Path=iif(Semi>0,substr(Path,Semi+1),"")
    Fname=Nextdir+"\"+Anyfile
  ENDDO    
  RETURN iif(file(Fname),Fname,"")
ENDIF  

*    Change dBASE color area settings to those in
*    "C_" variables

PROCEDURE cchange
SET COLOR OF NORM TO &C_norm
SET COLOR OF MESS TO &C_mess
SET COLOR OF TITL TO &C_titl
SET COLOR OF BOX  TO &C_box
SET COLOR OF HIGH TO &C_high
SET COLOR OF INFO TO &C_info
SET COLOR OF FIEL TO &C_fiel
RETURN

*    Write to binary file named in the call, using
*    values held as ASCII hexadecimals in the range
*    0-FF, one in the first field of each record
*    of the current and open .dbf file.  
*    Overwrites any existing file of the same name
*    and cancels printer setting.

PROCEDURE Binwrite
PARAMETERS Binfile
PRIVATE N,Fieldname
Fieldname=Field(1)
SET PRINTER TO FILE &Binfile
SCAN
  N=hextodec(&Fieldname)
  ??? iif(N=0,"{0}",chr(N))  
ENDSCAN    
SET PRINTER TO
RETURN  

*    Make a .DBF file of the given name with the given
*    array of fields.
*    Make .DBT file of same name if a memo field is
*    specified.
*    On return, file(s) is or are created.
*    They contain no data and are not opened.
*    Any existing file of the same name will be
*    overwritten and destroyed.
*    Cancels printer setting in effect before call.

*    Fields are specified in an array of dimensions
*    "[<number of fields>,4]" where second
*    dimension is name, type, length and decimals--
*    first two are character type, last two numeric.

*    Sample syntax:

*    DECLARE F[6,4]     && six fields for this file
*    F[1,1]="HEADING"
*    F[1,2]="C"
*    F[1,3]=7
*    F[1,4]=0

*    Remaining assignments have been compressed;
*    in practice use separate lines as above.

*    F[2, 1 . . . 4]="NOTES","M",10,0
*    F[3, 1 . . . 4]="TODAY","D",8,0
*    F[4, 1 . . . 4]="FLOAT","F",15,3
*    F[5, 1 . . . 4]="NUMBER","N",11,0
*    F[6, 1 . . . 4]="LOGIC","L",1,0

*    DO make_dbf WITH "Newfile.dbf","F",6

PROCEDURE make_dbf
PARAMETERS Filename,Arr,Fnum
PRIVATE X,Y,Hedlen,Reclen,Memo,Fields,Fname
Fname=iif("." $ Filename,;
  left(Filename,at(".",Filename)-1),trim(Filename))
DECLARE Fields[Fnum,4]
Memo=.F.              && flag for memo (.dbt) file
Hedlen=33             && header length with no fields
STORE 1 TO X,Reclen   && record length with no fields
DO WHILE X<=Fnum 
  Y=1
  DO WHILE Y<5
    Fields[X,Y]=&Arr.[X,Y]
    Y=Y+1
  ENDDO
  Fields[X,1]=upper(Fields[X,1])
  Fields[X,2]=upper(Fields[X,2])
  Memo=iif(Fields[X,2]="M",.T.,Memo) 
  Fields[X,3]=iif(Fields[X,2] $ "DLM",;
    val(substr("080110",2*at(Fields[X,2],"DLM")-1,2)),;
    Fields[X,3])
  Reclen=Reclen+Fields[X,3] && calculate record length
  Fields[X,4]= ;
    iif(.NOT. Fields[X,2] $ "FN",0,[Fields[X,4])
  Hedlen=Hedlen+32          && and header length
  X=X+1
ENDDO
SET PRINTER TO FILE (Fname+".DBF")
??? iif(Memo,chr(139),chr(3))     && file type ID byte
??? chr(mod(year(date()),100))+chr(month(date())) ;
  +chr(day(date()))               && date
??? "{0}{0}{0}{0}"                && no records yet
X=mod(Hedlen,256)
Y=int(Hedlen/256)
??? iif(X=0,"{0}",chr(X))+ ;
  iif(Y=0,"{0}",chr(Y)) && header length doubleword
X=mod(Reclen,256)
Y=int(Reclen/256)
??? iif(X=0,"{0}",chr(X))+ ;
  iif(Y=0,"{0}",chr(Y)) && record length doubleword
??? replicate("{0}",20) && reserved/waste bytes
X=1                     && add the array of fields
DO WHILE X<=Fnum
  ??? Fields[X,1]+replicate("{0}",;
     11-len(trim(Fields[X,1])))
  ??? Fields[X,2]+"{0}{0}{0}{0}"+chr(Fields[X,3]);
     +iif(Fields[X,4]>0,chr(Fields[X,4]),"{0}")
  ??? replicate("{0}",14)
  X=X+1
ENDDO
??? chr(13)             && finish the header
IF Memo                 && add the .dbt file if needed
  SET PRINTER TO FILE (Fname+".DBT")
  ??? chr(1)+replicate("{0}",7)
  ??? upper(Fname)+replicate("{0}",10-len(Fname))
  ??? chr(2)+chr(1)+"{0}"+chr(2)+"{0}{0}"
ENDIF       
SET PRINTER TO
RETURN                  
