;       showit.asm - writes characters and attributes
;       at current cursor position of current video
;       page.  Cannot wrap lines.

;       Expects two character arguments, the ASCIIZ
;       string to be written and the attribute byte.
;       No values returned.

;	Syntax:
;		LOAD showit

;               CALL showit WITH "hello",chr(78)

;       This program must be assembled and linked, then
;       converted to a binary image file by EXE2BIN.
;       It cannot be converted to a .COM file.
                       
;       Assembly option:

        CGA equ 1

;       Change the above to "CGA equ 0" if CGA snow
;       is not a problem.

        .model tiny
        code segment
        assume cs:code

showit  proc far

IF      CGA
        xor bp,bp               ; save no-cga flag
        mov ah,12h              ; get EGA/VGA info
        mov bl,10h
        int 10h
        cmp bl,10h              ; did this change?
        jnz gmode               ; if change,no cga
        dec bp                  ; else set cga flag
ENDIF

gmode:  mov ah,0Fh
        int 10h                 ; get mode and page

IF      CGA
        cmp bp,0
        jz read                 ; go if no cga
        cmp al,7                ; mono mode?
        jnz read
        inc bp                  ; mono is not cga
ENDIF

read:   mov ah,3                ; read cursor position
        int 10h
        lds si,es:[di]+4        ; get attribute
        mov bl,[si]
        mov cx,1                ; don't repeat char
        lds si,es:[di]          ; point to string

IF      CGA
        cmp bp,0                ; writing to cga?
        jz write                ; no
        push dx                 ; save cursor
        mov dx,03dah            ; CGA status port
wait1:  in al,dx                ; check status
        test al,00001000b       ; doing vert. retrace?
        jnz wait1               ; then wait for its end
wait2:  in al,dx
        test al,00001000b       ; wait for next start
        jz wait2
        pop dx
ENDIF

write:  lodsb
        cmp al,0                ; at end of string?
        jz sret                 ; done if so
        mov ah,9                ; write char and attribute
        int 10h
        inc dl                  ; bump cursor
        mov ah,2                ; set cursor position
        int 10h
        jmp short write

sret:   ret                     ; all done
showit  endp

code    ends
        end

